diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TaxonServiceImpl.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TaxonServiceImpl.java
index 17b57e526c..93a59ef937 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TaxonServiceImpl.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TaxonServiceImpl.java
@@ -1468,75 +1925,91 @@ public class TaxonServiceImpl extends IdentifiableServiceBase<TaxonBase,ITaxonDa
      * @param directorySelectClass
      * @return
      */
-    protected LuceneSearch prepareByDescriptionElementFullTextSearch(Class<? extends CdmBase> clazz, String queryString, Classification classification, List<Feature> features,
+    protected LuceneSearch prepareByDescriptionElementFullTextSearch(Class<? extends CdmBase> clazz,
+            String queryString, Classification classification, List<Feature> features,
             List<Language> languages, boolean highlightFragments) {
-        BooleanQuery finalQuery = new BooleanQuery();
-        BooleanQuery textQuery = new BooleanQuery();
 
-        LuceneSearch luceneSearch = new LuceneSearch(getSession(), GroupByTaxonClassBridge.GROUPBY_TAXON_FIELD, DescriptionElementBase.class);
-        QueryFactory queryFactory = new QueryFactory(luceneSearch);
+        LuceneSearch luceneSearch = new LuceneSearch(luceneIndexToolProvider, GroupByTaxonClassBridge.GROUPBY_TAXON_FIELD, DescriptionElementBase.class);
+        QueryFactory descriptionElementQueryFactory = luceneIndexToolProvider.newQueryFactoryFor(DescriptionElementBase.class);
 
         SortField[] sortFields = new  SortField[]{SortField.FIELD_SCORE, new SortField("inDescription.taxon.titleCache__sort", SortField.STRING, false)};
+
+        BooleanQuery finalQuery = createByDescriptionElementFullTextQuery(queryString, classification, features,
+                languages, descriptionElementQueryFactory);
+
         luceneSearch.setSortFields(sortFields);
+        luceneSearch.setCdmTypRestriction(clazz);
+        luceneSearch.setQuery(finalQuery);
+        if(highlightFragments){
+            luceneSearch.setHighlightFields(descriptionElementQueryFactory.getTextFieldNamesAsArray());
+        }
 
-        // ---- search criteria
-        luceneSearch.setClazz(clazz);
-        textQuery.add(queryFactory.newTermQuery("titleCache", queryString), Occur.SHOULD);
+        return luceneSearch;
+    }
+
+    /**
+     * @param queryString
+     * @param classification
+     * @param features
+     * @param languages
+     * @param descriptionElementQueryFactory
+     * @return
+     */
+    private BooleanQuery createByDescriptionElementFullTextQuery(String queryString, Classification classification,
+            List<Feature> features, List<Language> languages, QueryFactory descriptionElementQueryFactory) {
+        BooleanQuery finalQuery = new BooleanQuery();
+        BooleanQuery textQuery = new BooleanQuery();
+        textQuery.add(descriptionElementQueryFactory.newTermQuery("titleCache", queryString), Occur.SHOULD);
 
         // common name
         Query nameQuery;
         if(languages == null || languages.size() == 0){
-            nameQuery = queryFactory.newTermQuery("name", queryString);
+            nameQuery = descriptionElementQueryFactory.newTermQuery("name", queryString);
         } else {
             nameQuery = new BooleanQuery();
             BooleanQuery languageSubQuery = new BooleanQuery();
             for(Language lang : languages){
-                languageSubQuery.add(queryFactory.newTermQuery("language.uuid",  lang.getUuid().toString(), false), Occur.SHOULD);
+                languageSubQuery.add(descriptionElementQueryFactory.newTermQuery("language.uuid",  lang.getUuid().toString(), false), Occur.SHOULD);
             }
-            ((BooleanQuery) nameQuery).add(queryFactory.newTermQuery("name", queryString), Occur.MUST);
+            ((BooleanQuery) nameQuery).add(descriptionElementQueryFactory.newTermQuery("name", queryString), Occur.MUST);
             ((BooleanQuery) nameQuery).add(languageSubQuery, Occur.MUST);
         }
         textQuery.add(nameQuery, Occur.SHOULD);
 
 
         // text field from TextData
-        textQuery.add(queryFactory.newMultilanguageTextQuery("text", queryString, languages), Occur.SHOULD);
+        textQuery.add(descriptionElementQueryFactory.newMultilanguageTextQuery("text", queryString, languages), Occur.SHOULD);
 
         // --- TermBase fields - by representation ----
         // state field from CategoricalData
-        textQuery.add(queryFactory.newDefinedTermQuery("states.state", queryString, languages), Occur.SHOULD);
+        textQuery.add(descriptionElementQueryFactory.newDefinedTermQuery("stateData.state", queryString, languages), Occur.SHOULD);
 
         // state field from CategoricalData
-        textQuery.add(queryFactory.newDefinedTermQuery("states.modifyingText", queryString, languages), Occur.SHOULD);
+        textQuery.add(descriptionElementQueryFactory.newDefinedTermQuery("stateData.modifyingText", queryString, languages), Occur.SHOULD);
 
         // area field from Distribution
-        textQuery.add(queryFactory.newDefinedTermQuery("area", queryString, languages), Occur.SHOULD);
+        textQuery.add(descriptionElementQueryFactory.newDefinedTermQuery("area", queryString, languages), Occur.SHOULD);
 
         // status field from Distribution
-        textQuery.add(queryFactory.newDefinedTermQuery("status", queryString, languages), Occur.SHOULD);
+        textQuery.add(descriptionElementQueryFactory.newDefinedTermQuery("status", queryString, languages), Occur.SHOULD);
 
         finalQuery.add(textQuery, Occur.MUST);
         // --- classification ----
 
         if(classification != null){
-            finalQuery.add(queryFactory.newEntityIdQuery("inDescription.taxon.taxonNodes.classification.id", classification), Occur.MUST);
+            finalQuery.add(descriptionElementQueryFactory.newEntityIdQuery("inDescription.taxon.taxonNodes.classification.id", classification), Occur.MUST);
         }
 
         // --- IdentifieableEntity fields - by uuid
         if(features != null && features.size() > 0 ){
-            finalQuery.add(queryFactory.newEntityUuidQuery("feature.uuid", features), Occur.MUST);
+            finalQuery.add(descriptionElementQueryFactory.newEntityUuidsQuery("feature.uuid", features), Occur.MUST);
         }
 
         // the description must be associated with a taxon
-        finalQuery.add(queryFactory.newIsNotNullQuery("inDescription.taxon.id"), Occur.MUST);
+        finalQuery.add(descriptionElementQueryFactory.newIsNotNullQuery("inDescription.taxon.id"), Occur.MUST);
 
         logger.info("prepareByDescriptionElementFullTextSearch() query: " + finalQuery.toString());
-        luceneSearch.setQuery(finalQuery);
-
-        if(highlightFragments){
-            luceneSearch.setHighlightFields(queryFactory.getTextFieldNamesAsArray());
-        }
-        return luceneSearch;
+        return finalQuery;
     }
 
     /**
@@ -1936,9 +2409,9 @@ public class TaxonServiceImpl extends IdentifiableServiceBase<TaxonBase,ITaxonDa
         String idInSourceSyn= getIdInSource(syn);
 
         if (idInSourceParent != null && idInSourceSyn != null) {
-            IdentifiableSource originalSource = IdentifiableSource.NewInstance(idInSourceSyn + "; " + idInSourceParent, POTENTIAL_COMBINATION_NAMESPACE, sourceReference, null);
+            IdentifiableSource originalSource = IdentifiableSource.NewInstance(OriginalSourceType.Transformation, idInSourceSyn + "; " + idInSourceParent, POTENTIAL_COMBINATION_NAMESPACE, sourceReference, null);
             inferredSynName.addSource(originalSource);
-            originalSource = IdentifiableSource.NewInstance(idInSourceSyn + "; " + idInSourceParent, POTENTIAL_COMBINATION_NAMESPACE, sourceReference, null);
+            originalSource = IdentifiableSource.NewInstance(OriginalSourceType.Transformation, idInSourceSyn + "; " + idInSourceParent, POTENTIAL_COMBINATION_NAMESPACE, sourceReference, null);
             potentialCombination.addSource(originalSource);
         }
 
@@ -1999,19 +2472,23 @@ public class TaxonServiceImpl extends IdentifiableServiceBase<TaxonBase,ITaxonDa
 
         // Add the original source
         if (idInSourceSyn != null && idInSourceTaxon != null) {
-            IdentifiableSource originalSource = IdentifiableSource.NewInstance(idInSourceSyn + "; " + idInSourceTaxon, INFERRED_GENUS_NAMESPACE, sourceReference, null);
+            IdentifiableSource originalSource = IdentifiableSource.NewInstance(OriginalSourceType.Transformation, 
+            		idInSourceSyn + "; " + idInSourceTaxon, INFERRED_GENUS_NAMESPACE, sourceReference, null);
             inferredGenus.addSource(originalSource);
 
-            originalSource = IdentifiableSource.NewInstance(idInSourceSyn + "; " + idInSourceTaxon, INFERRED_GENUS_NAMESPACE, sourceReference, null);
+            originalSource = IdentifiableSource.NewInstance(OriginalSourceType.Transformation, 
+            		idInSourceSyn + "; " + idInSourceTaxon, INFERRED_GENUS_NAMESPACE, sourceReference, null);
             inferredSynName.addSource(originalSource);
             originalSource = null;
 
         }else{
             logger.error("There is an idInSource missing: " + idInSourceSyn + " of Synonym or " + idInSourceTaxon + " of Taxon");
-            IdentifiableSource originalSource = IdentifiableSource.NewInstance(idInSourceSyn + "; " + idInSourceTaxon, INFERRED_GENUS_NAMESPACE, sourceReference, null);
+            IdentifiableSource originalSource = IdentifiableSource.NewInstance(OriginalSourceType.Transformation, 
+            		idInSourceSyn + "; " + idInSourceTaxon, INFERRED_GENUS_NAMESPACE, sourceReference, null);
             inferredGenus.addSource(originalSource);
 
-            originalSource = IdentifiableSource.NewInstance(idInSourceSyn + "; " + idInSourceTaxon, INFERRED_GENUS_NAMESPACE, sourceReference, null);
+            originalSource = IdentifiableSource.NewInstance(OriginalSourceType.Transformation, 
+            		idInSourceSyn + "; " + idInSourceTaxon, INFERRED_GENUS_NAMESPACE, sourceReference, null);
             inferredSynName.addSource(originalSource);
             originalSource = null;
         }
@@ -2042,9 +2519,7 @@ public class TaxonServiceImpl extends IdentifiableServiceBase<TaxonBase,ITaxonDa
         Reference<?> sourceReference = syn.getSec();
 
         if (sourceReference == null){
-            logger.warn("The synonym has no sec reference because it is a misapplied name! Take the sec reference of taxon");
-            //TODO:Remove
-            System.out.println("The synonym has no sec reference because it is a misapplied name! Take the sec reference of taxon" + taxon.getSec());
+            logger.warn("The synonym has no sec reference because it is a misapplied name! Take the sec reference of taxon" + taxon.getSec());
             sourceReference = taxon.getSec();
         }
 
@@ -2103,11 +2578,13 @@ public class TaxonServiceImpl extends IdentifiableServiceBase<TaxonBase,ITaxonDa
         String taxonId = idInSourceTaxon+ "; " + idInSourceSyn;
 
 
-        IdentifiableSource originalSource = IdentifiableSource.NewInstance(taxonId, INFERRED_EPITHET_NAMESPACE, sourceReference, null);
+        IdentifiableSource originalSource = IdentifiableSource.NewInstance(OriginalSourceType.Transformation, 
+        		taxonId, INFERRED_EPITHET_NAMESPACE, sourceReference, null);
 
         inferredEpithet.addSource(originalSource);
 
-        originalSource = IdentifiableSource.NewInstance(taxonId, INFERRED_EPITHET_NAMESPACE, sourceReference, null);
+        originalSource = IdentifiableSource.NewInstance(OriginalSourceType.Transformation, 
+        		taxonId, INFERRED_EPITHET_NAMESPACE, sourceReference, null);
 
         inferredSynName.addSource(originalSource);
 
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TermServiceImpl.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TermServiceImpl.java
index 8edbabc06f..dc11953cdb 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TermServiceImpl.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/TermServiceImpl.java
@@ -19,11 +19,11 @@ import java.util.Locale;
 import java.util.Set;
 import java.util.UUID;
 
+import org.apache.commons.lang.StringUtils;
 import org.apache.log4j.Logger;
 import org.springframework.beans.factory.annotation.Autowired;
 import org.springframework.beans.factory.annotation.Qualifier;
 import org.springframework.stereotype.Service;
-import org.springframework.transaction.annotation.Propagation;
 import org.springframework.transaction.annotation.Transactional;
 
 import eu.etaxonomy.cdm.api.service.DeleteResult.DeleteStatus;
@@ -40,7 +40,6 @@ import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.location.NamedArea;
 import eu.etaxonomy.cdm.model.location.NamedAreaLevel;
 import eu.etaxonomy.cdm.model.location.NamedAreaType;
-import eu.etaxonomy.cdm.model.location.TdwgArea;
 import eu.etaxonomy.cdm.model.media.Media;
 import eu.etaxonomy.cdm.persistence.dao.common.IDefinedTermDao;
 import eu.etaxonomy.cdm.persistence.dao.common.ILanguageStringBaseDao;
@@ -101,9 +100,19 @@ public class TermServiceImpl extends IdentifiableServiceBase<DefinedTermBase,IDe
 	 * @see eu.etaxonomy.cdm.api.service.ITermService#getAreaByTdwgAbbreviation(java.lang.String)
 	 */
 	public NamedArea getAreaByTdwgAbbreviation(String tdwgAbbreviation) {
-		//FIXME this is just a placeholder until it is decided where to implement this method 
-		//(see also FIXMEs in TdwgArea)
-		return TdwgArea.getAreaByTdwgAbbreviation(tdwgAbbreviation);
+		if (StringUtils.isBlank(tdwgAbbreviation)){ //TDWG areas should always have a label
+			return null;
+		}
+		List<NamedArea> list = dao.getDefinedTermByIdInVocabulary(tdwgAbbreviation, NamedArea.uuidTdwgAreaVocabulary, NamedArea.class, null, null);
+		if (list.isEmpty()){
+			return null;
+		}else if (list.size() == 1){
+			return list.get(0);
+		}else{
+			String message = "There is more then 1 (%d) TDWG area with the same abbreviated label. This is forbidden. Check the state of your database.";
+			throw new IllegalStateException(String.format(message, list.size()));
+		}
+		
 	}
 
 	public <T extends DefinedTermBase> Pager<T> getGeneralizationOf(T definedTerm, Integer pageSize, Integer pageNumber) {
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/VocabularyServiceImpl.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/VocabularyServiceImpl.java
index 987f4659c1..060d04e75c 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/VocabularyServiceImpl.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/VocabularyServiceImpl.java
@@ -23,6 +23,7 @@ import eu.etaxonomy.cdm.api.service.pager.impl.DefaultPagerImpl;
 import eu.etaxonomy.cdm.common.monitor.IProgressMonitor;
 import eu.etaxonomy.cdm.model.common.DefinedTermBase;
 import eu.etaxonomy.cdm.model.common.Language;
+import eu.etaxonomy.cdm.model.common.TermType;
 import eu.etaxonomy.cdm.model.common.TermVocabulary;
 import eu.etaxonomy.cdm.model.common.VocabularyEnum;
 import eu.etaxonomy.cdm.persistence.dao.common.ITermVocabularyDao;
@@ -70,6 +71,9 @@ public class VocabularyServiceImpl extends IdentifiableServiceBase<TermVocabular
 		return dao.listByTermClass(clazz, includeSubclasses, includeEmptyVocs,limit, start, orderHints, propertyPaths);
 	}
 	
+	public <T extends DefinedTermBase> List<TermVocabulary<T>> findByTermType(TermType termType) {
+		return dao.findByTermType(termType);
+	}
 	/** 
 	 * (non-Javadoc)
 	 * @see eu.etaxonomy.cdm.api.service.ITermService#getLanguageVocabulary()
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/pager/impl/AbstractPagerImpl.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/pager/impl/AbstractPagerImpl.java
index 7a7d09afe1..3d51f34da2 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/pager/impl/AbstractPagerImpl.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/pager/impl/AbstractPagerImpl.java
@@ -1,9 +1,9 @@
 // $Id$
 /**
  * Copyright (C) 2009 EDIT
- * European Distributed Institute of Taxonomy 
+ * European Distributed Institute of Taxonomy
  * http://www.e-taxonomy.eu
- * 
+ *
  * The contents of this file are subject to the Mozilla Public License Version 1.1
  * See LICENSE.TXT at the top of this package for the full license terms.
  */
@@ -41,8 +41,8 @@ public abstract class AbstractPagerImpl<T> implements Pager<T>, Serializable {
 
 	/**
 	 * Constructor
-	 * 
-	 * @param currentIndex the page of this result set (0-based), can be null 
+	 *
+	 * @param currentIndex the page of this result set (0-based), can be null
 	 * @param count the total number of results available for this query
 	 * @param pageSize The size of pages (can be null if all results should be returned if available)
 	 * @param records A list of objects in this page (can be empty if there were no results)
@@ -52,11 +52,11 @@ public abstract class AbstractPagerImpl<T> implements Pager<T>, Serializable {
 		this(currentIndex,count,pageSize,records);
 		this.suggestion = suggestion;
 	}
-	
+
 	/**
 	 * Constructor
-	 * 
-	 * @param currentIndex the page of this result set (0-based), can be null 
+	 *
+	 * @param currentIndex the page of this result set (0-based), can be null
 	 * @param count the total number of results available for this query
 	 * @param pageSize The size of pages (can be null or 0 if all results should be returned if available)
 	 * @param records A list of objects in this page (can be empty if there were no results)
@@ -67,7 +67,7 @@ public abstract class AbstractPagerImpl<T> implements Pager<T>, Serializable {
         } else {
         	this.currentIndex = 0;
         }
-		
+
         this.pageSize = pageSize;
 		this.pageNumbers = new HashMap<Integer,String>();
 		indices = new ArrayList<Integer>();
@@ -95,7 +95,7 @@ public abstract class AbstractPagerImpl<T> implements Pager<T>, Serializable {
 				}
 			} else {
 				pagesAvailable = (count / pageSize) + 1; //12
-				
+
 				Integer labelsStart = 0;
                 if(this.currentIndex > DefaultPagerImpl.MAX_PAGE_LABELS) {
                     labelsStart = this.currentIndex - DefaultPagerImpl.MAX_PAGE_LABELS;
@@ -106,13 +106,13 @@ public abstract class AbstractPagerImpl<T> implements Pager<T>, Serializable {
 					labelsEnd = this.currentIndex + DefaultPagerImpl.MAX_PAGE_LABELS;
 					for(int index = labelsStart; index < labelsEnd; index++) {
 						indices.add(index);
-						
+
 						String startLabel = getLabel(index * pageSize);
 						String endLabel = getLabel(((index + 1) * pageSize) - 1);
 						pageNumbers.put(index,createLabel(startLabel,endLabel));
 					}
-					
-					
+
+
 				} else {
 					for(int index = labelsStart; index < (labelsEnd -1); index++) {
 						indices.add(index);
@@ -126,12 +126,12 @@ public abstract class AbstractPagerImpl<T> implements Pager<T>, Serializable {
 					pageNumbers.put(pagesAvailable.intValue() - 1,createLabel(startLabel,endLabel));
 				}
 
-				
+
 			}
 		} else {
 			pagesAvailable = 1;
 		}
-		
+
 		if(pagesAvailable == 1) {
 			nextIndex = null;
 			prevIndex = null;
@@ -150,70 +150,82 @@ public abstract class AbstractPagerImpl<T> implements Pager<T>, Serializable {
     		this.firstRecord = (this.currentIndex * pageSize) + 1;
 	    	this.lastRecord = (this.currentIndex * pageSize) + records.size();
 		}
-	    	
-		this.count = count; 
+
+		this.count = count;
 		this.records = records;
 	}
 
-	protected abstract String createLabel(String startLabel, String endLabel); 
-	
+	protected abstract String createLabel(String startLabel, String endLabel);
+
 	protected String getLabel(Integer i) {
 		Integer label = new Integer(i + 1);
 		return label.toString();
 	}
 
+	@Override
 	public Integer getPagesAvailable() {
 		return pagesAvailable;
 	}
 
+	@Override
 	public Integer getNextIndex() {
 		return nextIndex;
 	}
 
+	@Override
 	public Integer getPrevIndex() {
 		return prevIndex;
 	}
 
+	@Override
 	public Integer getCurrentIndex() {
 		return currentIndex;
 	}
 
+	@Override
 	public String getPageNumber(int index) {
 		return pageNumbers.get(index);
 	}
 
+	@Override
 	public List<Integer> getIndices() {
 		return indices;
 	}
 
+	@Override
 	public Integer getCount() {
 		return count;
 	}
 
+	@Override
 	public Integer getFirstRecord() {
 		return firstRecord;
 	}
 
+	@Override
 	public Integer getLastRecord() {
 		return lastRecord;
 	}
 
+	@Override
 	public List<T> getRecords() {
 		return records;
 	}
 
+	@Override
 	public String getSuggestion() {
 		return suggestion;
 	}
 
+	@Override
 	public Integer getPageSize() {
 		return pageSize;
 	}
 
-	public static boolean hasResultsInRange(Integer numberOfResults, Integer pageNumber, Integer pageSize) {
-		return numberOfResults > 0 // no results at all 
+	public static boolean hasResultsInRange(Long numberOfResults, Integer pageNumber, Integer pageSize) {
+		return numberOfResults > 0 // no results at all
 				&& (pageSize == null // page size may be null : return all in this case
-				|| pageNumber != null && pageSize != null && numberOfResults >= (pageNumber * pageSize));
+				|| pageNumber != null && numberOfResults > (pageNumber * pageSize));
 	}
 
 }
\ No newline at end of file
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/CdmMassIndexer.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/CdmMassIndexer.java
index e461690f88..e3357650bc 100644
--- a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/CdmMassIndexer.java
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/CdmMassIndexer.java
@@ -53,6 +53,7 @@ import eu.etaxonomy.cdm.model.name.TaxonNameBase;
 import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;
 import eu.etaxonomy.cdm.model.taxon.Classification;
 import eu.etaxonomy.cdm.model.taxon.TaxonBase;
+import eu.etaxonomy.cdm.model.taxon.TaxonRelationship;
 
 /**
  * @author Andreas Kohlbecker
@@ -63,7 +64,7 @@ import eu.etaxonomy.cdm.model.taxon.TaxonBase;
 @Transactional
 public class CdmMassIndexer implements ICdmMassIndexer {
 
-	private Set<Class<? extends CdmBase>> indexedClasses = new HashSet<Class<? extends CdmBase>>();
+    private final Set<Class<? extends CdmBase>> indexedClasses = new HashSet<Class<? extends CdmBase>>();
     public static final Logger logger = Logger.getLogger(CdmMassIndexer.class);
 
     /*
@@ -223,27 +224,39 @@ public class CdmMassIndexer implements ICdmMassIndexer {
         logger.info("purging " + type.getName());
         fullTextSession.purgeAll(type);
 
+        // TODO
+        // toggle on/off flag doSpellIndex introduced for debugging, see ticket:
+        //  #3721 (CdmMassIndexer.purge throwing errors due to LockObtainFailedException)
+        // remove once this is fixed
+        boolean doSpellIndex = false;
+
+        if(doSpellIndex){
+            SearchFactoryImplementor searchFactory = (SearchFactoryImplementor)fullTextSession.getSearchFactory();
+            IndexManager indexManager = searchFactory.getAllIndexesManager().getIndexManager(type.getName());
+            if(indexManager == null){
+                logger.info("No IndexManager found for " + type.getName() + ", thus nothing to purge");
+                return;
+            }
 
-        SearchFactoryImplementor searchFactory = (SearchFactoryImplementor)fullTextSession.getSearchFactory();
-        IndexManager indexManager = searchFactory.getAllIndexesManager().getIndexManager(type.getName());
-        Directory directory = ((DirectoryBasedIndexManager) indexManager).getDirectoryProvider().getDirectory();
-        SpellChecker spellChecker = null;
-        try {
-            spellChecker = new SpellChecker(directory);
-            spellChecker.clearIndex();
-        } catch (IOException e) {
-            logger.error("IOException when creating dictionary", e);
-            //TODO better means to notify that the process has been stopped, using the STOPPED_WORK_INDICATOR is only a hack
-            monitor.worked(RestServiceProgressMonitor.STOPPED_WORK_INDICATOR);
-            monitor.done();
-        }
-
-        if (spellChecker != null) {
+            Directory directory = ((DirectoryBasedIndexManager) indexManager).getDirectoryProvider().getDirectory();
+            SpellChecker spellChecker = null;
             try {
-                logger.info("closing spellchecker ");
-                spellChecker.close();
+                spellChecker = new SpellChecker(directory);
+                spellChecker.clearIndex();
             } catch (IOException e) {
-                logger.error("IOException when closing spellchecker", e);
+                logger.error("IOException when creating dictionary", e);
+                //TODO better means to notify that the process has been stopped, using the STOPPED_WORK_INDICATOR is only a hack
+                monitor.worked(RestServiceProgressMonitor.STOPPED_WORK_INDICATOR);
+                monitor.done();
+            }
+
+            if (spellChecker != null) {
+                try {
+                    logger.info("closing spellchecker ");
+                    spellChecker.close();
+                } catch (IOException e) {
+                    logger.error("IOException when closing spellchecker", e);
+                }
             }
         }
     }
@@ -253,28 +266,31 @@ public class CdmMassIndexer implements ICdmMassIndexer {
      * @see eu.etaxonomy.cdm.database.IMassIndexer#reindex()
      */
     @Override
-    public void reindex(IProgressMonitor monitor){
+    public void reindex(Set<Class<? extends CdmBase>> types, IProgressMonitor monitor){
 
         if(monitor == null){
             monitor = new NullProgressMonitor();
         }
+        if(types == null){
+            types = indexedClasses();
+        }
 
         monitor.setTaskName("CdmMassIndexer");
-        int steps = indexedClasses().size() + 1; // +1 for optimize
-        monitor.beginTask("Reindexing " + indexedClasses().size() + " classes", steps);
+        int steps = types.size() + 1; // +1 for optimize
+        monitor.beginTask("Reindexing " + types.size() + " classes", steps);
 
-        for(Class<? extends CdmBase> type : indexedClasses()){
+        for(Class<? extends CdmBase> type : types){
             reindex(type, monitor);
         }
 
         monitor.subTask("Optimizing Index");
         SubProgressMonitor subMonitor = new SubProgressMonitor(monitor, 1);
         subMonitor.beginTask("Optimizing Index",1);
-        optimize();        
+        optimize();
         subMonitor.worked(1);
         logger.info("end index optimization");
         subMonitor.done();
-        
+
         //monitor.worked(1);
         monitor.done();
     }
@@ -374,15 +390,16 @@ public class CdmMassIndexer implements ICdmMassIndexer {
     @SuppressWarnings("unchecked")
     @Override
     public Set<Class<? extends CdmBase>> indexedClasses() {
-    	// if no indexed classes have been 'manually' set then
-    	// the default is the full list
-    	if(indexedClasses.size() == 0) {
-    		indexedClasses.add(DescriptionElementBase.class);
-    		indexedClasses.add(TaxonBase.class);    		
-    		indexedClasses.add(Classification.class);
-    		indexedClasses.add(TaxonNameBase.class);
-    		indexedClasses.add(SpecimenOrObservationBase.class);
-    	}
+        // if no indexed classes have been 'manually' set then
+        // the default is the full list
+        if(indexedClasses.size() == 0) {
+            indexedClasses.add(DescriptionElementBase.class);
+            indexedClasses.add(TaxonBase.class);
+            indexedClasses.add(Classification.class);
+            indexedClasses.add(TaxonNameBase.class);
+            indexedClasses.add(SpecimenOrObservationBase.class);
+            indexedClasses.add(TaxonRelationship.class);
+        }
         return indexedClasses;
     }
 
@@ -396,16 +413,6 @@ public class CdmMassIndexer implements ICdmMassIndexer {
                 };
     }
 
-	@Override
-	public void addToIndexedClasses(Class<? extends CdmBase> cdmBaseClass) {
-		indexedClasses.add(cdmBaseClass);
-		
-	}
-
-	@Override
-	public void clearIndexedClasses() {
-		indexedClasses.clear();		
-	}
 
 
 }
\ No newline at end of file
diff --git a/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/DocIdBitSetPrinter.java b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/DocIdBitSetPrinter.java
new file mode 100644
index 0000000000..ad29c69a61
--- /dev/null
+++ b/cdmlib-services/src/main/java/eu/etaxonomy/cdm/api/service/search/DocIdBitSetPrinter.java
@@ -0,0 +1,49 @@
+// $Id$
+/**
+* Copyright (C) 2013 EDIT
+* European Distributed Institute of Taxonomy
+* http://www.e-taxonomy.eu
+*
+* The contents of this file are subject to the Mozilla Public License Version 1.1
+* See LICENSE.TXT at the top of this package for the full license terms.
+*/
+package eu.etaxonomy.cdm.api.service.search;
+
+import java.io.IOException;
+
+import org.apache.log4j.Logger;
+import org.apache.lucene.search.DocIdSet;
+import org.apache.lucene.search.DocIdSetIterator;
+
+/**
+ * Helper class, for printing out information on {@link DocIdSet}s
+ *
+ * @author a.kohlbecker
+ * @date Sep 24, 2013
+ *
+ */
+public class DocIdBitSetPrinter {
+
+    public static final Logger logger = Logger.getLogger(DocIdBitSetPrinter.class);
+
+    public static String docsAsString(DocIdSet docset, int maxdocs){
+
+        StringBuilder sb = new StringBuilder();
+        try {
+            DocIdSetIterator it = docset.iterator();
+            int i = 0;
+            while(i < maxdocs){
+                int docId = it.nextDoc();
+                if(docId == DocIdSetIterator.NO_MORE_DOCS){
+                    break;
+                }
+                sb.append(docId).append(" ");
+            }
+        } catch (IOException e) {
+            logger.error("Error while reding doc ids from DocIdSet", e);
+        }
+
+        return sb.toString();
+    }
+
+}
